=== src/CMakeLists.txt ===

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/flexiblas_api.h.in ${CMAKE_BINARY_DIR}/include/flexiblas_api.h)


ADD_SUBDIRECTORY(fallback_blas)

IF(LAPACK)
ADD_SUBDIRECTORY(fallback_lapack)
ENDIF()

SET (COMMON_SRC
	mgmt/hooks.c
	mgmt.c
    paths.c
    hooks.c
    utils.c
    sh_utils.c
	flexiblas_printf.c
    common.c
)

SET ( SRC
	flexiblas.c
	flexiblas_api.c
	loader.c
	hook_loader.c
	xerbla.c
	lsame.c
	set_num_threads.c
	wrap_cblas.c
    cabs.c
    ${COMMON_SRC}
)

SET (FLEXIBLAS_MGMT_SRC
    ${COMMON_SRC}
)

SET (FLEXIBLAS_API_SRC
	flexiblas_api_standalone.c
)

IF ( FLEXIBLAS_ABI_INTEL)
	SET (SRC ${SRC} wrapper_blas_intel.c)
ELSE ()
	SET (SRC ${SRC} wrapper_blas_gnu.c)
ENDIF()


SET ( CBLAS_SRC
	# Globlas
	cblas_interface/cblas_globals.c
	cblas_interface/cblas_xerbla.c
	# Double
	cblas_interface/cblas_dasum.c
	cblas_interface/cblas_daxpy.c
	cblas_interface/cblas_dcopy.c
	cblas_interface/cblas_ddot.c
	cblas_interface/cblas_dgbmv.c
	cblas_interface/cblas_dgemm.c
	cblas_interface/cblas_dgemv.c
	cblas_interface/cblas_dger.c
	cblas_interface/cblas_dnrm2.c
	cblas_interface/cblas_drot.c
	cblas_interface/cblas_drotg.c
	cblas_interface/cblas_drotm.c
	cblas_interface/cblas_drotmg.c
	cblas_interface/cblas_dsbmv.c
	cblas_interface/cblas_dscal.c
	cblas_interface/cblas_dsdot.c
	cblas_interface/cblas_dspmv.c
	cblas_interface/cblas_dspr.c
	cblas_interface/cblas_dspr2.c
	cblas_interface/cblas_dswap.c
	cblas_interface/cblas_dsymm.c
	cblas_interface/cblas_dsymv.c
	cblas_interface/cblas_dsyr.c
	cblas_interface/cblas_dsyr2.c
	cblas_interface/cblas_dsyr2k.c
	cblas_interface/cblas_dsyrk.c
	cblas_interface/cblas_dtbmv.c
	cblas_interface/cblas_dtbsv.c
	cblas_interface/cblas_dtpmv.c
	cblas_interface/cblas_dtpsv.c
	cblas_interface/cblas_dtrmm.c
	cblas_interface/cblas_dtrmv.c
	cblas_interface/cblas_dtrsm.c
	cblas_interface/cblas_dtrsv.c
	cblas_interface/cblas_dzasum.c
	cblas_interface/cblas_dznrm2.c
	cblas_interface/cblas_idamax.c
	# Single
	cblas_interface/cblas_sasum.c
	cblas_interface/cblas_saxpy.c
	cblas_interface/cblas_scasum.c
	cblas_interface/cblas_scnrm2.c
	cblas_interface/cblas_scopy.c
	cblas_interface/cblas_sdot.c
	cblas_interface/cblas_sdsdot.c
	cblas_interface/cblas_sgbmv.c
	cblas_interface/cblas_sgemm.c
	cblas_interface/cblas_sgemv.c
	cblas_interface/cblas_sger.c
	cblas_interface/cblas_snrm2.c
	cblas_interface/cblas_srot.c
	cblas_interface/cblas_srotg.c
	cblas_interface/cblas_srotm.c
	cblas_interface/cblas_srotmg.c
	cblas_interface/cblas_ssbmv.c
	cblas_interface/cblas_sscal.c
	cblas_interface/cblas_sspmv.c
	cblas_interface/cblas_sspr2.c
	cblas_interface/cblas_sspr.c
	cblas_interface/cblas_sswap.c
	cblas_interface/cblas_ssymm.c
	cblas_interface/cblas_ssymv.c
	cblas_interface/cblas_ssyr2.c
	cblas_interface/cblas_ssyr2k.c
	cblas_interface/cblas_ssyr.c
	cblas_interface/cblas_ssyrk.c
	cblas_interface/cblas_stbmv.c
	cblas_interface/cblas_stbsv.c
	cblas_interface/cblas_stpmv.c
	cblas_interface/cblas_stpsv.c
	cblas_interface/cblas_strmm.c
	cblas_interface/cblas_strmv.c
	cblas_interface/cblas_strsm.c
	cblas_interface/cblas_strsv.c
	cblas_interface/cblas_isamax.c
	# Complex Single
	cblas_interface/cblas_caxpy.c
	cblas_interface/cblas_ccopy.c
	cblas_interface/cblas_cdotc_sub.c
	cblas_interface/cblas_cdotu_sub.c
	cblas_interface/cblas_cgbmv.c
	cblas_interface/cblas_cgemm.c
	cblas_interface/cblas_cgemv.c
	cblas_interface/cblas_cgerc.c
	cblas_interface/cblas_cgeru.c
	cblas_interface/cblas_chbmv.c
	cblas_interface/cblas_chemm.c
	cblas_interface/cblas_chemv.c
	cblas_interface/cblas_cher2.c
	cblas_interface/cblas_cher2k.c
	cblas_interface/cblas_cher.c
	cblas_interface/cblas_cherk.c
	cblas_interface/cblas_chpmv.c
	cblas_interface/cblas_chpr2.c
	cblas_interface/cblas_chpr.c
	cblas_interface/cblas_crotg.c
	cblas_interface/cblas_csrot.c
	cblas_interface/cblas_cscal.c
	cblas_interface/cblas_csscal.c
	cblas_interface/cblas_cswap.c
	cblas_interface/cblas_csymm.c
	cblas_interface/cblas_csyr2k.c
	cblas_interface/cblas_csyrk.c
	cblas_interface/cblas_ctbmv.c
	cblas_interface/cblas_ctbsv.c
	cblas_interface/cblas_ctpmv.c
	cblas_interface/cblas_ctpsv.c
	cblas_interface/cblas_ctrmm.c
	cblas_interface/cblas_ctrmv.c
	cblas_interface/cblas_ctrsm.c
	cblas_interface/cblas_ctrsv.c
	cblas_interface/cblas_icamax.c
	# Complex Double
	cblas_interface/cblas_zaxpy.c
	cblas_interface/cblas_zcopy.c
	cblas_interface/cblas_zdotc_sub.c
	cblas_interface/cblas_zdotu_sub.c
	cblas_interface/cblas_zgbmv.c
	cblas_interface/cblas_zgemm.c
	cblas_interface/cblas_zgemv.c
	cblas_interface/cblas_zgerc.c
	cblas_interface/cblas_zgeru.c
	cblas_interface/cblas_zhbmv.c
	cblas_interface/cblas_zhemm.c
	cblas_interface/cblas_zhemv.c
	cblas_interface/cblas_zher2.c
	cblas_interface/cblas_zher2k.c
	cblas_interface/cblas_zher.c
	cblas_interface/cblas_zherk.c
	cblas_interface/cblas_zhpmv.c
	cblas_interface/cblas_zhpr2.c
	cblas_interface/cblas_zhpr.c
    cblas_interface/cblas_zrotg.c
    cblas_interface/cblas_zdrot.c
	cblas_interface/cblas_zscal.c
	cblas_interface/cblas_zdscal.c
	cblas_interface/cblas_zswap.c
	cblas_interface/cblas_zsymm.c
    cblas_interface/cblas_zsyr2k.c
	cblas_interface/cblas_zsyrk.c
	cblas_interface/cblas_ztbmv.c
	cblas_interface/cblas_ztbsv.c
	cblas_interface/cblas_ztpmv.c
	cblas_interface/cblas_ztpsv.c
	cblas_interface/cblas_ztrmm.c
	cblas_interface/cblas_ztrmv.c
	cblas_interface/cblas_ztrsm.c
	cblas_interface/cblas_ztrsv.c
	cblas_interface/cblas_izamax.c
    cblas_interface/cblas_daxpby.c
    cblas_interface/cblas_saxpby.c
    cblas_interface/cblas_caxpby.c
    cblas_interface/cblas_zaxpby.c
    cblas_interface/cblas_simatcopy.c
    cblas_interface/cblas_dimatcopy.c
    cblas_interface/cblas_cimatcopy.c
    cblas_interface/cblas_zimatcopy.c
    cblas_interface/cblas_somatcopy.c
    cblas_interface/cblas_domatcopy.c
    cblas_interface/cblas_comatcopy.c
    cblas_interface/cblas_zomatcopy.c
    cblas_interface/cblas_dgeadd.c
    cblas_interface/cblas_cgeadd.c
    cblas_interface/cblas_zgeadd.c
    cblas_interface/cblas_sgeadd.c


    )
IF (CBLAS STREQUAL ON)
	SET (SRC ${SRC} ${CBLAS_SRC})
ENDIF()

#
# LAPACK
#
IF ( LAPACK )
	# 3.7.1 and 3.7.0 share the same api/abi
	IF(LAPACK_API_VERSION STREQUAL "3.12.0")
		SET(_LAPACK_FILE_SUFFIX 3_12_0)
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.12.0-wodprc")
		SET(_LAPACK_FILE_SUFFIX 3_12_0-wodprc) #
    ELSEIF(LAPACK_API_VERSION STREQUAL "3.11.0")
		SET(_LAPACK_FILE_SUFFIX 3_11_0)
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.11.0-wodprc")
		SET(_LAPACK_FILE_SUFFIX 3_11_0-wodprc) #
    ELSEIF(LAPACK_API_VERSION STREQUAL "3.10.1")
		SET(_LAPACK_FILE_SUFFIX 3_10_1)
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.10.1-wodprc")
		SET(_LAPACK_FILE_SUFFIX 3_10_1-wodprc) #
    ELSEIF(LAPACK_API_VERSION STREQUAL "3.10.0")
		SET(_LAPACK_FILE_SUFFIX 3_10_0)
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.10.0-wodprc")
		SET(_LAPACK_FILE_SUFFIX 3_10_0-wodprc) #
    ELSEIF(LAPACK_API_VERSION STREQUAL "3.9.1")
		SET(_LAPACK_FILE_SUFFIX 3_9_1)
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.9.1-wodprc")
		SET(_LAPACK_FILE_SUFFIX 3_9_1-wodprc) #
    ELSEIF(LAPACK_API_VERSION STREQUAL "3.9.0")
		SET(_LAPACK_FILE_SUFFIX 3_9_0)
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.9.0-wodprc")
		SET(_LAPACK_FILE_SUFFIX 3_9_0-wodprc) #
    ELSEIF(LAPACK_API_VERSION STREQUAL "3.8.0")
		SET(_LAPACK_FILE_SUFFIX 3_8_0)
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.8.0-wodprc")
		SET(_LAPACK_FILE_SUFFIX 3_8_0-wodprc) #
	ELSEIF(LAPACK_API_VERSION STREQUAL "3.7.1")
		SET(_LAPACK_FILE_SUFFIX 3_7_0)
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.7.1-wodprc")
		SET(_LAPACK_FILE_SUFFIX 3_7_0-wodprc) #
	ELSEIF(LAPACK_API_VERSION STREQUAL "3.7.0")
		SET(_LAPACK_FILE_SUFFIX 3_7_0)
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.7.0-wodprc")
		SET(_LAPACK_FILE_SUFFIX 3_7_0-wodprc) #
	ELSEIF(LAPACK_API_VERSION STREQUAL "3.6.1")
		SET(_LAPACK_FILE_SUFFIX 3_6_1)
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.6.1-wodprc")
		SET(_LAPACK_FILE_SUFFIX 3_6_1-wodprc) #
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.6.0")
		SET(_LAPACK_FILE_SUFFIX 3_6_0) #
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.6.0-wodprc")
		SET(_LAPACK_FILE_SUFFIX 3_6_0-wodprc) #
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.5.0")
		SET(_LAPACK_FILE_SUFFIX 3_5_0) #
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.4.2")
		SET(_LAPACK_FILE_SUFFIX 3_4_2) #
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.4.1")
		SET(_LAPACK_FILE_SUFFIX 3_4_1) #
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.4.0")
		SET(_LAPACK_FILE_SUFFIX 3_4_0) #
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.3.1")
		SET(_LAPACK_FILE_SUFFIX 3_3_1) #
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.3.0")
		SET(_LAPACK_FILE_SUFFIX 3_3_0) #
	ENDIF()
	INCLUDE(lapack_interface/lapack_${_LAPACK_FILE_SUFFIX}.cmake)

	SET (SRC ${SRC} ${LAPACK_SRC} lapack_interface/ilaver.c
		lapack_interface/load_lapack_${_LAPACK_FILE_SUFFIX}.c
        lapack_interface/load_lapack_${_LAPACK_FILE_SUFFIX}_fallback.c
	)

	FILE(COPY lapack_interface/lapack_${_LAPACK_FILE_SUFFIX}.h DESTINATION ${PROJECT_BINARY_DIR}/include/)
	FILE(RENAME  ${PROJECT_BINARY_DIR}/include/lapack_${_LAPACK_FILE_SUFFIX}.h ${PROJECT_BINARY_DIR}/include/lapack.h)
	FILE(COPY lapack_interface/flexiblas_real_lapack_${_LAPACK_FILE_SUFFIX}.h DESTINATION ${PROJECT_BINARY_DIR}/include/)
	FILE(RENAME  ${PROJECT_BINARY_DIR}/include/flexiblas_real_lapack_${_LAPACK_FILE_SUFFIX}.h ${PROJECT_BINARY_DIR}/include/flexiblas_real_lapack.h)

ENDIF()

FIND_PACKAGE(OpenMP)

INCLUDE_DIRECTORIES(${INCLUDE_DIR} ${CMAKE_CURRENT_SOURCE_DIR})
add_library(flexiblas SHARED ${SRC}) #  $<TARGET_OBJECTS:cscutils_src>)
add_executable(flexiblas-tool flexiblas_tool.c tool/hookhandling.c tool/blashandling.c ${COMMON_SRC} ) # $<TARGET_OBJECTS:cscutils_src>)

IF (LINK_OPENMP)
    TARGET_LINK_LIBRARIES(flexiblas ${LIBS} cscutils OpenMP::OpenMP_C)
    TARGET_LINK_LIBRARIES(flexiblas-tool PRIVATE flexiblas_mgmt ${LIBS} cscutils OpenMP::OpenMP_C)
ELSE()
    TARGET_LINK_LIBRARIES(flexiblas ${LIBS} cscutils) # OpenMP::OpenMP_C)
    TARGET_LINK_LIBRARIES(flexiblas-tool PRIVATE flexiblas_mgmt ${LIBS} cscutils) # OpenMP::OpenMP_C)
ENDIF()


add_library(flexiblas_mgmt SHARED ${FLEXIBLAS_MGMT_SRC}) # $<TARGET_OBJECTS:cscutils_src>)
TARGET_LINK_LIBRARIES(flexiblas_mgmt ${LIBS} cscutils )

add_library(flexiblas_api SHARED ${FLEXIBLAS_API_SRC} ) # $<TARGET_OBJECTS:cscutils_src>)
TARGET_LINK_LIBRARIES(flexiblas_api ${DL_LIB} cscutils c)

set(GENERIC_LIB_VERSION "${FLEXIBLAS_VERSION_MAJOR}.${FLEXIBLAS_VERSION_MINOR}")
set(GENERIC_LIB_SOVERSION "${FLEXIBLAS_VERSION_MAJOR}")


add_executable(flexiblas-config flexiblas-config.c)

IF ( C_W_PEDANTIC )
    target_compile_options(flexiblas PRIVATE "-Wpedantic")
    target_compile_options(flexiblas-tool PRIVATE "-Wpedantic")
    target_compile_options(flexiblas_mgmt PRIVATE "-Wpedantic")
    target_compile_options(flexiblas_api PRIVATE "-Wpedantic")
    target_compile_options(flexiblas-config PRIVATE "-Wpedantic")
ENDIF()






IF ( NOT ${CMAKE_C_COMPILER_ID} MATCHES "XL")
 	SET_TARGET_PROPERTIES(flexiblas PROPERTIES VERSION ${GENERIC_LIB_VERSION} SOVERSION ${GENERIC_LIB_SOVERSION} LINK_FLAGS "-Bsymbolic" )
 	SET_TARGET_PROPERTIES(flexiblas_mgmt PROPERTIES VERSION ${GENERIC_LIB_VERSION} SOVERSION ${GENERIC_LIB_SOVERSION} LINK_FLAGS "-Bsymbolic" )
 	SET_TARGET_PROPERTIES(flexiblas_api PROPERTIES VERSION ${GENERIC_LIB_VERSION} SOVERSION ${GENERIC_LIB_SOVERSION} LINK_FLAGS "-Bsymbolic" )
ENDIF()



IF (FLEXIBLAS_ABI_INTEL)
	SET_TARGET_PROPERTIES(flexiblas PROPERTIES OUTPUT_NAME flexiblas_intel)
ENDIF()

IF (FLEXIBLAS_ABI_IBM)
	SET_TARGET_PROPERTIES(flexiblas PROPERTIES OUTPUT_NAME flexiblas_xl)
ENDIF()


IF(INTEGER8 STREQUAL ON)
	SET_TARGET_PROPERTIES(flexiblas      PROPERTIES OUTPUT_NAME ${flexiblasname})
	SET_TARGET_PROPERTIES(flexiblas_api  PROPERTIES OUTPUT_NAME ${flexiblasname}_api)
	SET_TARGET_PROPERTIES(flexiblas_mgmt PROPERTIES OUTPUT_NAME ${flexiblasname}_mgmt)
	SET_TARGET_PROPERTIES(flexiblas-tool PROPERTIES OUTPUT_NAME ${flexiblasname})
    SET_TARGET_PROPERTIES(flexiblas-config PROPERTIES OUTPUT_NAME ${flexiblasname}-config)

	IF (USE_INTERFACE_INTEL)
