=== debian/changelog ===
flexiblas (3.4.1) UNRELEASED; urgency=medium

  * New patch release. See CHANGELOG

 -- Martin Koehler <koehlerm@mpi-magdeburg.mpg.de>  Wed, 10 Jan 2024 15:06:20 +0100

flexiblas (3.4.0) focal; urgency=medium

  * New minor release. See CHANGELOG

 -- Martin Koehler <koehlerm@mpi-magdeburg.mpg.de>  Tue, 09 Jan 2024 13:21:12 +0100

flexiblas (3.3.0) focal; urgency=medium

  * New minor release. See CHANGELOG

 -- Martin Köhler <koehlerm@mpi-magdeburg.mpg.de>  Mon, 19 Dec 2022 20:52:04 +0100

flexiblas (3.2.1) focal; urgency=medium

  * Bugfix release. See CHANGELOG

 -- Martin Koehler <koehlerm@mpi-magdeburg.mpg.de>  Tue, 12 Jul 2022 12:00:00 +0100

flexiblas (3.2.0) focal; urgency=medium

  * New minor release. See CHANGELOG

 -- Martin Koehler <koehlerm@mpi-magdeburg.mpg.de>  Thu, 17 May 2022 12:00:00 +0100

flexiblas (3.1.3) focal; urgency=medium

  * Bugfix release for 3.1.0

 -- Martin Koehler <koehlerm@mpi-magdeburg.mpg.de>  Fri, 22 Jan 2022 20:00:00 +0100

flexiblas (3.1.2) focal; urgency=medium

  * Bugfix release for 3.1.0

 -- Martin Koehler <koehlerm@mpi-magdeburg.mpg.de>  Mon, 17 Jan 2022 20:00:00 +0100

flexiblas (3.1.1) focal; urgency=medium

  * Bugfix release for 3.1.0

 -- Martin Koehler <koehlerm@mpi-magdeburg.mpg.de>  Mon, 17 Jan 2022 12:00:00 +0100

flexiblas (3.1.0) focal; urgency=medium

  * See CHANGELOG

 -- Martin Koehler <koehlerm@mpi-magdeburg.mpg.de>  Sun, 16 Jan 2022 12:00:00 +0100

flexiblas (3.0.4) focal; urgency=medium

  * Closes #107: DCABS1 and SCABS1 missing
  * Closes #105: Could not compile on FreeBSD
  * Closes #104: Missing prefix in some outputs of xerbla.c
  * Closes #103: GH #7 - LAPACK decompositions do not run in parallel
  * Closes #102: GH #6 - Wrong return type.

 -- Martin Koehler <koehlerm@mpi-magdeburg.mpg.de>  Thu, 22 Oct 2020 10:52:54 +0200

flexiblas (3.0.3) focal; urgency=medium

  * Close #101: DLAMC3 and SLAMC3 missing

 -- Martin Koehler <koehlerm@mpi-magdeburg.mpg.de>  Fri, 28 Aug 2020 14:35:54 +0200

flexiblas (3.0.2) focal; urgency=medium

  * Close #99, #100: Include codegens in source

 -- Martin Köhler <koehlerm@mpi-magdeburg.mpg.de>  Thu, 23 Jul 2020 09:58:03 +0200

flexiblas (3.0.1) focal; urgency=medium

  * Close #97: Hooks are loaded up to LAPACK 3.9.0
  * Close #92: CBLAS works with 64bit integer values on big-endian
  * Close #94: LSAMEN with implicit casting returns wrong values on big-endian
             systems.
  * Close #95: Failed looking up symbols from hooks when used from Python
  * Close #91: Manpages still reference GPLv2+


 -- Martin Köhler <koehlerm@mpi-magdeburg.mpg.de>  Wed, 01 Jul 2020 09:05:35 +0200

flexiblas (3.0.0) focal; urgency=medium

  * Rewrite of the hook System
  * 32 and 64 bit integer builds can coexist
  * detection of the BLIS library


 -- Martin Köhler <koehlerm@mpi-magdeburg.mpg.de>  Wed, 01 Jul 2020 09:05:23 +0200

flexiblas (2.0.0) unstable; urgency=medium

  * Fixed: Bug/Crash if default backend does not exist
  * New Benchmark Tool (AXPY,GEMM,GEMV unified, latency tests)
  * Rewrite the FlexiBLAS tool to use a common management library.
  * Include LAPACK Interface (Maximum API Level 3.7.0)
  * Update CBLAS tests to current versions
  * Many fixes and code rewrites

 -- Martin Köhler <koehlerm@mpi-magdeburg.mpg.de>  Fri, 26 Feb 2016 16:31:56 +0100

flexiblas (1.3.0) unstable; urgency=low

  * Add s/d/c/z geadd function from ATLAS/OpenBLAS
  * Allow to overload BLAS functions using hooks.
  * Runtime switching of BLAS libraries.
  * Profiling information in now held in the structure of the correponding BLAS
    functions, but accumulated in the end.
  * Configuration is done using libcscutils/ini, i.e., we have an ini-file like
    configuration system.
  * flexiblas command line tool redesigned.
  * BLAS routines can be replaced in the backends. See
    src/backends/demo/backend.c for details.
  * The wrapper are generated via code generation software.
  * Different integer sizes are supported. Each routine comes with a default
    integer variant (which is either 32 or 64 bit selected at compile time.) and
    additionally a 32 and 64 bit interface. (experimental, please do not use in
    production code)
  * Code cleanup
  * Octave Interface

 -- Martin Köhler <koehlerm@mpi-magdeburg.mpg.de>  Wed, 04 Nov 2015 15:00:00 +0200

flexiblas (1.2.0) unstable; urgency=low

  * add s/d/c/z axpby as BLAS extension (Like in OpenBLAS or MKL)
  * add s/d/c/z omatcopy as BLAS extension, following both APIs (OpenBLAS and MKL)
  * add s/d/c/z imatcopy as BLAS extension, following both APIs (OpenBLAS and MKL)
    new configure option: -DDEV=ON/OFF  to enable development builds the run only
  * in the build directory. Default is OFF.
  * user supplied XERBLA functions now work with ACML and MKL
  * add CBLAS tests
  * working 8-byte integer support

 -- Martin Köhler <koehlerm@mpi-magdeburg.mpg.de>  Thu, 06 Nov 2014 15:00:00 +0200

flexiblas (1.1.1) unstable; urgency=low

  * fix DSCABS1

 -- Martin Köhler <koehlerm@mpi-magdeburg.mpg.de>  Thu, 04 Sep 2014 15:00:00 +0200

flexiblas (1.1.0) unstable; urgency=low

  * Combine flexiblas and fleixblas-profile
  * internal rewriting
  * support additional search paths in the config files


 -- Martin Köhler <koehlerm@mpi-magdeburg.mpg.de>  Thu, 04 Sep 2014 15:00:00 +0200

flexiblas (1.0.1) unstable; urgency=low

  * Fixed SCABS1

 --  Martin Köhler <koehlerm@mpi-magdeburg.mpg.de>  Wed, 30 Apr  2014 11:15:00 +0100

flexiblas (1.0.0) unstable; urgency=low

  * Lift version to 1.0.0

 --  Martin Köhler <koehlerm@mpi-magdeburg.mpg.de>  Wed, 08 Jan 2014 10:36:45 +0100

flexiblas (0.1.0) unstable; urgency=low

  * Initial Release.

 -- Martin Köhler <koehlerm@mpi-magdeburg.mpg.de>  Wed, 11 Sep 2013 08:37:42 +0200
