=== debian/control ===
Source: flexiblas
Priority: optional
Maintainer: Martin Köhler <koehlerm@mpi-magdeburg.mpg.de>
Build-Depends: debhelper (>= 11.0.0), cmake, gfortran (>= 5.1.0), gcc (>= 5.1.0), libatlas-base-dev (>= 3.8.0),
 libopenblas-openmp-dev, libopenblas-pthread-dev, libopenblas-serial-dev,
 libopenblas64-openmp-dev, libopenblas64-pthread-dev, libopenblas64-serial-dev,
 libblis-openmp-dev, libblis-pthread-dev, libblis-serial-dev,
 libblis64-openmp-dev, libblis64-pthread-dev, libblis64-serial-dev,
 libblas-dev, libblas64-dev, liblapack-dev, liblapack64-dev, libmkl-dev [amd64]
Standards-Version: 4.5.0
Section: libs
Homepage: http://www.mpi-magdeburg.mpg.de/projects/flexiblas

Package: libflexiblas
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Flexible and Exchangeable BLAS library.
 The FlexiBLAS library is a flexible BLAS wrapper
 which allows one to exchange the system wide BLAS
 implementation without recompiling or relinking programs.
 Even dealing with runtime-loader specific tricks is
 not necessary with FlexiBLAS.
 .
 You can select the BLAS implementation which is used behind
 FlexiBLAS using a configuration file or a environment variable.
 It is integrated in Debian/Ubuntu using the update-alternatives
 mechanism.
 .
 The package supports OpenBLAS, ATLAS and the reference Netlib
 implementation. If you compile FlexiBLAS on your own, other
 BLAS implementations like the old GotoBLAS or the Intel MKL
 are supported.
 .
 This package contains the runtime part of FlexiBLAS.

Package: libflexiblas64
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Flexible and Exchangeable BLAS library (64bit integers).
 The FlexiBLAS library is a flexible BLAS wrapper
 which allows one to exchange the system wide BLAS
 implementation without recompiling or relinking programs.
 Even dealing with runtime-loader specific tricks is
 not necessary with FlexiBLAS.
 .
 You can select the BLAS implementation which is used behind
 FlexiBLAS using a configuration file or a environment variable.
 It is integrated in Debian/Ubuntu using the update-alternatives
 mechanism.
 .
 The package supports OpenBLAS, ATLAS and the reference Netlib
 implementation. If you compile FlexiBLAS on your own, other
 BLAS implementations like the old GotoBLAS or the Intel MKL
 are supported.
 .
 This package contains the runtime part of FlexiBLAS. It contains
 the 64 bit integer library of FlexiBLAS.

Package: libflexiblas-bin
Section: admin
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Flexible and Exchangeable BLAS library. Management Tool.
 The FlexiBLAS library is a flexible BLAS wrapper
 which allows one to exchange the system wide BLAS
 implementation without recompiling or relinking programs.
 Even dealing with runtime-loader specific tricks is
 not necessary with FlexiBLAS.
 .
 You can select the BLAS implementation which is used behind
 FlexiBLAS using a configuration file or a environment variable.
 It is integrated in Debian/Ubuntu using the update-alternatives
 mechanism.
 .
 The package supports OpenBLAS, ATLAS and the reference Netlib
 implementation. If you compile FlexiBLAS on your own, other
 BLAS implementations like the old GotoBLAS or the Intel MKL
 are supported.
 .
 This package contains the management tool for the FlexiBLAS
 library.

Package: libflexiblas64-bin
Section: admin
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Flexible and Exchangeable BLAS library. Management Tool. (64bit integers).
 The FlexiBLAS library is a flexible BLAS wrapper
 which allows one to exchange the system wide BLAS
 implementation without recompiling or relinking programs.
 Even dealing with runtime-loader specific tricks is
 not necessary with FlexiBLAS.
 .
 You can select the BLAS implementation which is used behind
 FlexiBLAS using a configuration file or a environment variable.
 It is integrated in Debian/Ubuntu using the update-alternatives
 mechanism.
 .
 The package supports OpenBLAS, ATLAS and the reference Netlib
 implementation. If you compile FlexiBLAS on your own, other
 BLAS implementations like the old GotoBLAS or the Intel MKL
 are supported.
 .
 This package contains the management tool for the 64 bit integer
 version of FlexiBLAS.


Package: libflexiblas-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libflexiblas (= ${binary:Version}), libblas-dev, liblapack-dev, ${misc:Depends}
Description: Development files for libflexiblas.
 The FlexiBLAS library is a flexible BLAS wrapper
 which allows one to exchange the system wide BLAS
 implementation without recompiling or relinking programs.
 Even dealing with runtime-loader specific tricks is
 not necessary with FlexiBLAS.
 .
 You can select the BLAS implementation which is used behind
 FlexiBLAS using a configuration file or a environment variable.
 It is integrated in Debian/Ubuntu using the update-alternatives
 mechanism.
 .
 The package supports OpenBLAS, ATLAS and the reference Netlib
 implementation. If you compile FlexiBLAS on your own, other
 BLAS implementations like the old GotoBLAS or the Intel MKL
 are supported.
 .
 This package contains the development files.

Package: libflexiblas64-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libflexiblas64 (= ${binary:Version}), libblas64-dev, liblapack64-dev, ${misc:Depends}
Description: Development files for libflexiblas64.
 The FlexiBLAS library is a flexible BLAS wrapper
 which allows one to exchange the system wide BLAS
 implementation without recompiling or relinking programs.
 Even dealing with runtime-loader specific tricks is
 not necessary with FlexiBLAS.
 .
 You can select the BLAS implementation which is used behind
 FlexiBLAS using a configuration file or a environment variable.
 It is integrated in Debian/Ubuntu using the update-alternatives
 mechanism.
 .
 The package supports OpenBLAS, ATLAS and the reference Netlib
 implementation. If you compile FlexiBLAS on your own, other
 BLAS implementations like the old GotoBLAS or the Intel MKL
 are supported.
 .
 This package contains the development files for the 64 bit
 integer build.

Package: libflexiblas-api
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Flexible and Exchangeable BLAS library. Standalone API
 The FlexiBLAS library is a flexible BLAS wrapper
 which allows one to exchange the system wide BLAS
 implementation without recompiling or relinking programs.
 Even dealing with runtime-loader specific tricks is
 not necessary with FlexiBLAS.
 .
 You can select the BLAS implementation which is used behind
 FlexiBLAS using a configuration file or a environment variable.
 It is integrated in Debian/Ubuntu using the update-alternatives
 mechanism.
 .
 The package supports OpenBLAS, ATLAS and the reference Netlib
 implementation. If you compile FlexiBLAS on your own, other
 BLAS implementations like the old GotoBLAS or the Intel MKL
 are supported.
 .
 This package contains the standalone API of FlexiBLAS.

Package: libflexiblas64-api
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Flexible and Exchangeable BLAS library. Standalone API (64bit integers).
 The FlexiBLAS library is a flexible BLAS wrapper
 which allows one to exchange the system wide BLAS
 implementation without recompiling or relinking programs.
 Even dealing with runtime-loader specific tricks is
 not necessary with FlexiBLAS.
 .
 You can select the BLAS implementation which is used behind
 FlexiBLAS using a configuration file or a environment variable.
 It is integrated in Debian/Ubuntu using the update-alternatives
 mechanism.
 .
 The package supports OpenBLAS, ATLAS and the reference Netlib
 implementation. If you compile FlexiBLAS on your own, other
 BLAS implementations like the old GotoBLAS or the Intel MKL
 are supported.
 .
 This package contains the standalone API of FlexiBLAS with 64bit
 integers.


Package: libflexiblas-api-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libflexiblas-api (= ${binary:Version}), ${misc:Depends}
Description: Flexible and Exchangeable BLAS library. Standalone API. Development Files.
 The FlexiBLAS library is a flexible BLAS wrapper
 which allows one to exchange the system wide BLAS
 implementation without recompiling or relinking programs.
 Even dealing with runtime-loader specific tricks is
 not necessary with FlexiBLAS.
 .
 You can select the BLAS implementation which is used behind
 FlexiBLAS using a configuration file or a environment variable.
 It is integrated in Debian/Ubuntu using the update-alternatives
 mechanism.
 .
 The package supports OpenBLAS, ATLAS and the reference Netlib
 implementation. If you compile FlexiBLAS on your own, other
 BLAS implementations like the old GotoBLAS or the Intel MKL
 are supported.
 .
 This package contains the development files for the
 standalone API of FlexiBLAS.

Package: libflexiblas64-api-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libflexiblas64-api (= ${binary:Version}), libflexiblas-api-dev (= ${binary:Version}), ${misc:Depends}
Description: Flexible and Exchangeable BLAS library. Standalone API. Development Files.
 The FlexiBLAS library is a flexible BLAS wrapper
 which allows one to exchange the system wide BLAS
 implementation without recompiling or relinking programs.
 Even dealing with runtime-loader specific tricks is
 not necessary with FlexiBLAS.
 .
 You can select the BLAS implementation which is used behind
 FlexiBLAS using a configuration file or a environment variable.
 It is integrated in Debian/Ubuntu using the update-alternatives
 mechanism.
 .
 The package supports OpenBLAS, ATLAS and the reference Netlib
 implementation. If you compile FlexiBLAS on your own, other
 BLAS implementations like the old GotoBLAS or the Intel MKL
 are supported.
 .
 This package contains the development files of the
 standalone API of FlexiBLAS with 64 bit integers.

Package: libflexiblas-hook-profile
Section: libs
Architecture: any
Multi-Arch: same
Depends:  libflexiblas (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Profile Addion for FlexiBLAS
 The FlexiBLAS library is a flexible BLAS wrapper
 which allows one to exchange the system wide BLAS
 implementation without recompiling or relinking programs.
 Even dealing with runtime-loader specific tricks is
 not necessary with FlexiBLAS.
 .
 The profile hook allows easy profiling of BLAS and LAPACK
 related function calls.

Package: libflexiblas64-hook-profile
Section: libs
Architecture: any
Multi-Arch: same
Depends:  libflexiblas (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Profile Addion for FlexiBLAS (64 bit integer)
 The FlexiBLAS library is a flexible BLAS wrapper
 which allows one to exchange the system wide BLAS
 implementation without recompiling or relinking programs.
 Even dealing with runtime-loader specific tricks is
 not necessary with FlexiBLAS.
 .
 The profile hook allows easy profiling of BLAS and LAPACK
 related function calls.

Package: libflexiblas-atlas
Section: libs
Architecture: any
Multi-Arch: same
Depends: libflexiblas (= ${binary:Version}), libatlas3-base, ${misc:Depends}
Description: ATLAS backend for FlexiBLAS
 The FlexiBLAS library is a flexible BLAS wrapper
 which allows one to exchange the system wide BLAS
 implementation without recompiling or relinking programs.
 Even dealing with runtime-loader specific tricks is
 not necessary with FlexiBLAS.
 .
 This package contains the ATLAS backend for FlexiBLAS.

Package: libflexiblas-openblas-serial
Section: libs
Architecture: any
Multi-Arch: same
Depends: libflexiblas (= ${binary:Version}), libopenblas0-serial, ${misc:Depends}
Description: OpenBLAS Serial backend for FlexiBLAS
